<?php
/* Autor...:  */
/* Esquema.: TR_Ruta.xml */
/* Generado: 2020-08-18 04:21:31 */

/* Metodos de acceso a los campos de la tabla TR_Ruta */
abstract class BaseTR_RutaBN
{
    /* Campos de la tabla */
    private $i_IdRuta;    // IdRuta: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $s_RutaDocumento;    // RutaDocumento: ( no definido )
    private $d_RutaFechaProgramada;    // RutaFechaProgramada: ( no definido )
    private $i_IdTurno;    // IdTurno: ( no definido )
    private $i_IdVehiculo;    // IdVehiculo: ( no definido )
    private $i_IdChofer;    // IdChofer: ( no definido )
    private $d_RutaFechaEmision;    // RutaFechaEmision: ( no definido )
    private $d_RutaFechaPartida;    // RutaFechaPartida: ( no definido )
    private $d_RutaFechaLlegada;    // RutaFechaLlegada: ( no definido )
    private $u_RutaComentario;    // RutaComentario: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdRuta */
    public function setIdRuta( $i_IdRuta )
    {
        $this->i_IdRuta = $i_IdRuta;
    }

    /* Obtiene el valor del campo IdRuta */
    public function getIdRuta()
    {
        return $this->i_IdRuta;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo RutaDocumento */
    public function setRutaDocumento( $s_RutaDocumento )
    {
        $this->s_RutaDocumento = $s_RutaDocumento;
    }

    /* Obtiene el valor del campo RutaDocumento */
    public function getRutaDocumento()
    {
        return $this->s_RutaDocumento;
    }

    /* Establece el valor del campo RutaFechaProgramada */
    public function setRutaFechaProgramada( $d_RutaFechaProgramada )
    {
        $this->d_RutaFechaProgramada = $d_RutaFechaProgramada;
    }

    /* Obtiene el valor del campo RutaFechaProgramada */
    public function getRutaFechaProgramada()
    {
        return $this->d_RutaFechaProgramada;
    }

    /* Establece el valor del campo IdTurno */
    public function setIdTurno( $i_IdTurno )
    {
        $this->i_IdTurno = $i_IdTurno;
    }

    /* Obtiene el valor del campo IdTurno */
    public function getIdTurno()
    {
        return $this->i_IdTurno;
    }

    /* Establece el valor del campo IdVehiculo */
    public function setIdVehiculo( $i_IdVehiculo )
    {
        $this->i_IdVehiculo = $i_IdVehiculo;
    }

    /* Obtiene el valor del campo IdVehiculo */
    public function getIdVehiculo()
    {
        return $this->i_IdVehiculo;
    }

    /* Establece el valor del campo IdChofer */
    public function setIdChofer( $i_IdChofer )
    {
        $this->i_IdChofer = $i_IdChofer;
    }

    /* Obtiene el valor del campo IdChofer */
    public function getIdChofer()
    {
        return $this->i_IdChofer;
    }

    /* Establece el valor del campo RutaFechaEmision */
    public function setRutaFechaEmision( $d_RutaFechaEmision )
    {
        $this->d_RutaFechaEmision = $d_RutaFechaEmision;
    }

    /* Obtiene el valor del campo RutaFechaEmision */
    public function getRutaFechaEmision()
    {
        return $this->d_RutaFechaEmision;
    }

    /* Establece el valor del campo RutaFechaPartida */
    public function setRutaFechaPartida( $d_RutaFechaPartida )
    {
        $this->d_RutaFechaPartida = $d_RutaFechaPartida;
    }

    /* Obtiene el valor del campo RutaFechaPartida */
    public function getRutaFechaPartida()
    {
        return $this->d_RutaFechaPartida;
    }

    /* Establece el valor del campo RutaFechaLlegada */
    public function setRutaFechaLlegada( $d_RutaFechaLlegada )
    {
        $this->d_RutaFechaLlegada = $d_RutaFechaLlegada;
    }

    /* Obtiene el valor del campo RutaFechaLlegada */
    public function getRutaFechaLlegada()
    {
        return $this->d_RutaFechaLlegada;
    }

    /* Establece el valor del campo RutaComentario */
    public function setRutaComentario( $u_RutaComentario )
    {
        $this->u_RutaComentario = $u_RutaComentario;
    }

    /* Obtiene el valor del campo RutaComentario */
    public function getRutaComentario()
    {
        return $this->u_RutaComentario;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdRuta' => $this->getIdRuta(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'RutaDocumento' => $this->getRutaDocumento(),
            'RutaFechaProgramada' => $this->getRutaFechaProgramada(),
            'IdTurno' => $this->getIdTurno(),
            'IdVehiculo' => $this->getIdVehiculo(),
            'IdChofer' => $this->getIdChofer(),
            'RutaFechaEmision' => $this->getRutaFechaEmision(),
            'RutaFechaPartida' => $this->getRutaFechaPartida(),
            'RutaFechaLlegada' => $this->getRutaFechaLlegada(),
            'RutaComentario' => $this->getRutaComentario(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto TR_RutaBN desde un RecordSet */
    public static function retrieveByRs( $o_TR_RutaRs )
    {
        $o_TR_RutaBN = new TR_RutaBN();
        $o_TR_RutaBN->setIdRuta( ( integer ) $o_TR_RutaRs[ "IdRuta" ] );
        $o_TR_RutaBN->setIdCompania( ( integer ) $o_TR_RutaRs[ "IdCompania" ] );
        $o_TR_RutaBN->setIdSucursal( ( integer ) $o_TR_RutaRs[ "IdSucursal" ] );
        $o_TR_RutaBN->setRutaDocumento( $o_TR_RutaRs[ "RutaDocumento" ] );
        $o_TR_RutaBN->setRutaFechaProgramada( utilTimestamp::getTimestamp( $o_TR_RutaRs[ "RutaFechaProgramada" ], "Y-m-d H:i:s" ) );
        $o_TR_RutaBN->setIdTurno( ( integer ) $o_TR_RutaRs[ "IdTurno" ] );
        $o_TR_RutaBN->setIdVehiculo( ( integer ) $o_TR_RutaRs[ "IdVehiculo" ] );
        $o_TR_RutaBN->setIdChofer( ( integer ) $o_TR_RutaRs[ "IdChofer" ] );
        $o_TR_RutaBN->setRutaFechaEmision( utilTimestamp::getTimestamp( $o_TR_RutaRs[ "RutaFechaEmision" ], "Y-m-d H:i:s" ) );
        $o_TR_RutaBN->setRutaFechaPartida( utilTimestamp::getTimestamp( $o_TR_RutaRs[ "RutaFechaPartida" ], "Y-m-d H:i:s" ) );
        $o_TR_RutaBN->setRutaFechaLlegada( utilTimestamp::getTimestamp( $o_TR_RutaRs[ "RutaFechaLlegada" ], "Y-m-d H:i:s" ) );
        $o_TR_RutaBN->setRutaComentario( $o_TR_RutaRs[ "RutaComentario" ] );
        $o_TR_RutaBN->setEstado( $o_TR_RutaRs[ "Estado" ] );
        $o_TR_RutaBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_TR_RutaRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_TR_RutaBN->setUsuarioCreacion( $o_TR_RutaRs[ "UsuarioCreacion" ] );
        $o_TR_RutaBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_TR_RutaRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_TR_RutaBN->setUsuarioModificacion( $o_TR_RutaRs[ "UsuarioModificacion" ] );
        return $o_TR_RutaBN;
    }
}
?>